From 66927b32bbf318c590e4d7ad5b0ca10d62ffca88 Mon Sep 17 00:00:00 2001
From: Ralph Bean <rbean@redhat.com>
Date: Mar 31 2016 19:35:29 +0000
Subject: [PATCH 380/1001] Add a second tier of workers to the cascade.


---

diff --git a/check-queue-length.py b/check-queue-length.py
index 7121257..4fc7098 100755
--- a/check-queue-length.py
+++ b/check-queue-length.py
@@ -17,7 +17,8 @@ import fedmsg.config
 config = fedmsg.config.load_config()
 
 import retask
-queue = retask.queue.Queue(config['hubs.redis.work-queue-name'])
-queue.connect()
 
-print 'Cache worker queue length is', queue.length
+for item in ['triage', 'work']:
+    queue = retask.queue.Queue(config['hubs.redis.%s-queue-name' % item])
+    queue.connect()
+    print ' (%s) queue length is %i' % (item, queue.length)
diff --git a/fedmsg.d/testconfig.py b/fedmsg.d/testconfig.py
index 43e4c53..1f45487 100644
--- a/fedmsg.d/testconfig.py
+++ b/fedmsg.d/testconfig.py
@@ -5,8 +5,16 @@ config = {
     'hubs.sqlalchemy.uri': 'sqlite:////var/tmp/hubs.db',
 
     # For communication between fedmsg-hub and the cache worker farm
+    'hubs.redis.triage-queue-name': 'fedora-hubs-triage-queue',
     'hubs.redis.work-queue-name': 'fedora-hubs-work-queue',
 
+    # Junk junk junk.. that we don't care about.  Drop it!
+    'hubs.junk_suffixes': [
+        'buildsys.tag',
+        'buildsys.untag',
+        'buildsys.rpm.sign',
+    ],
+
     'endpoints': {
         "fedora-infrastructure": [
             "tcp://hub.fedoraproject.org:9940",
diff --git a/hubs/backend/consumer.py b/hubs/backend/consumer.py
new file mode 100755
index 0000000..9d73ef1
--- /dev/null
+++ b/hubs/backend/consumer.py
@@ -0,0 +1,34 @@
+# The fedora hubs backend daemon
+
+import fedmsg.consumers
+import fedmsg.meta
+
+import retask.task
+import retask.queue
+
+import logging
+log = logging.getLogger("hubs")
+
+
+class CacheInvalidatorExtraordinaire(fedmsg.consumers.FedmsgConsumer):
+    topic = '*'
+    config_key = 'hubs.consumer.enabled'
+
+    def __init__(self, *args, **kwargs):
+        log.debug("CacheInvalidatorExtraordinaire initializing")
+        super(CacheInvalidatorExtraordinaire, self).__init__(*args, **kwargs)
+
+        self.queue_name = self.hub.config['hubs.redis.triage-queue-name']
+
+        log.debug("CacheInvalidatorExtraordinaire initialized")
+
+    def consume(self, raw_msg):
+        msg = raw_msg['body']
+        queue = retask.queue.Queue(self.queue_name)
+        queue.connect()
+        task = retask.task.Task(fedmsg.encoding.dumps(msg))
+        queue.enqueue(task)
+
+    def stop(self):
+        log.info("Cleaning up CacheInvalidatorExtraordinaire.")
+        super(CacheInvalidatorExtraordinaire, self).stop()
diff --git a/hubs/backend/worker.py b/hubs/backend/worker.py
new file mode 100755
index 0000000..11c3342
--- /dev/null
+++ b/hubs/backend/worker.py
@@ -0,0 +1,100 @@
+#!/usr/bin/env python
+""" hubs backend worker process.
+
+This is step 3 of the backend cascading pipeline.
+
+consumer -> redis --+-> triage process -+-> redis --+-> worker process
+                    |          .        |           |          .
+                    +-> triage process -+           +-> worker process
+                               .                               .
+                               .                               .
+                               .                               .
+
+We expect to have lots of worker processes running, and that we will add more
+to scale out as our workload, usage of fedora-hubs, and the general bus volume
+all increase over time.
+
+The worker process is a last step in the pipeline.  It pulls tasks off of a
+redis queue fed by the triage worker farm.  For each item, it simply
+invalidates a cache value and then calls the appropriate widget `data()`
+function to rebuild that value.
+
+This isn't implemented yet, but at the end of the day it should *also* notify
+another redis queue so that an EventSource server can update any connected web
+clients with the new content produced here.
+"""
+
+import hubs.app
+import hubs.models
+
+import hubs.widgets.base
+
+import fedmsg.config
+import fedmsg.meta
+config = fedmsg.config.load_config()
+
+import retask.queue
+
+import json
+import sys
+import logging
+import logging.config
+log = logging.getLogger('hubs.backend.worker')
+
+
+def work(session, widget_idx):
+    # Get a real widget, because we update last_refreshed on it.
+    widget = hubs.models.Widget.by_idx(session, widget_idx)
+    log.info("! Invalidating cache for %r" % widget)
+    # Invalidate the cache...
+    hubs.widgets.base.invalidate_cache(widget, **widget.config)
+    # Rebuild it.
+    log.info("! Rebuilding cache for %r" % widget)
+    widget.module.data(session, widget, **widget.config)
+    # TODO -- fire off an EventSource notice that we updated stuff
+
+
+def handle(idx):
+    session = hubs.models.init(config['hubs.sqlalchemy.uri'])
+
+    try:
+        with hubs.app.app.app_context():  # so url_for works
+            work(session, idx)
+        session.commit()  # transaction is committed here
+    except:
+        session.rollback()  # rolls back the transaction
+        raise
+    finally:
+        session.close()
+
+
+def main(args):
+    logging.config.dictConfig(config['logging'])
+    logging.basicConfig()
+
+    fedmsg.meta.make_processors(**config)
+
+    # XXX - for flask.url_for to work
+    hubs.app.app.config['SERVER_NAME'] = '0.0.0.0:5000'
+
+    name = config['hubs.redis.work-queue-name']
+    log.info("Worker starting, connecting to retask queue %r." % name)
+    queue = retask.queue.Queue(name)
+    queue.connect()
+
+    try:
+        log.info("Entering work loop.")
+        while True:
+            task = queue.wait()  # Wait forever...  timeout is optional.
+            log.info("Working on %r.  (backlog is %r)" % (task, queue.length))
+            item = json.loads(task.data)
+            idx = item['idx']  # A widget ID
+            handle(idx)
+            log.debug("  Done.")
+    except KeyboardInterrupt:
+        pass
+
+    return 0
+
+if __name__ == '__main__':
+    sys.exit(main(sys.argv))
diff --git a/hubs/widgets/bugzilla.py b/hubs/widgets/bugzilla.py
index d524833..2576963 100644
--- a/hubs/widgets/bugzilla.py
+++ b/hubs/widgets/bugzilla.py
@@ -5,7 +5,7 @@ import hubs.validators as validators
 from hubs.widgets.base import argument
 from hubs.widgets.chrome import panel
 from hubs.widgets import templating
-from hubs.hinting import hint, prefixed as _
+from hubs.hinting import hint
 
 chrome = panel("Bugzilla: Issues")
 template = templating.environment.get_template('templates/bugzilla.html')
@@ -63,6 +63,18 @@ def data(session, widget, username):
     )
 
 
-@hint()
+@hint(categories=['bugzilla'])
 def should_invalidate(message, session, widget):
-    raise NotImplementedError
+    # TODO -- wrap this pkgdb pull in another invalidatible cache.
+    username = widget.config['username']
+    pkgdb_url = "https://admin.fedoraproject.org/pkgdb/api/packager/package"
+    url = "/".join([pkgdb_url, username])
+    response = requests.get(url)
+    data = response.json()
+
+    owned = data['point of contact'] + data['co-maintained']
+    owned = [p['name'] for p in owned]
+    if message['msg']['bug']['component'] in owned:
+        return True
+
+    return False
diff --git a/hubs/widgets/github_pr.py b/hubs/widgets/github_pr.py
index 905924c..89c8766 100755
--- a/hubs/widgets/github_pr.py
+++ b/hubs/widgets/github_pr.py
@@ -51,6 +51,13 @@ def data(session, widget, display_number, organization):
     )
 
 
-@hint()
+@hint(categories=['github'])
 def should_invalidate(message, session, widget):
-    raise NotImplementedError
+    owner = message['msg']['repository']['owner']
+
+    if 'login' in owner:
+        owner = owner['login']
+    else:
+        owner = owner['name']
+
+    return owner == widget.config['organization']
diff --git a/hubs/widgets/pagure_pr.py b/hubs/widgets/pagure_pr.py
index 59444db..350291d 100755
--- a/hubs/widgets/pagure_pr.py
+++ b/hubs/widgets/pagure_pr.py
@@ -48,6 +48,7 @@ def data(session, widget, repo):
     )
 
 
-@hint()
+# TODO -- this hint could be honed in more to just PRs
+@hint(categories=['pagure'])
 def should_invalidate(message, session, widget):
-    raise NotImplementedError
+    return message['msg']['project']['name'] == widget.config['repo']
diff --git a/setup.py b/setup.py
index 5a66e3e..6ddbd37 100644
--- a/setup.py
+++ b/setup.py
@@ -37,7 +37,7 @@ setup(
     ],
     entry_points={
         'moksha.consumer': [
-            "cache_invalidator = hubs.consumer:CacheInvalidatorExtraordinaire",
+            "cache_invalidator = hubs.backend.consumer:CacheInvalidatorExtraordinaire",
         ],
     },
 )

